#version 330 compatibility
// version 400 was released in 2010. https://en.wikipedia.org/wiki/OpenGL_Shading_Language

// matrixes
uniform mat4 MVP;			// camera transform modelview
uniform mat4 ModelMatrix;	// local model transform (is needed currently to render vehicles)
uniform mat4 ProjMatrix;	// current projection matrix

uniform sampler2D WorldRGB;
uniform sampler2D WorldLight;

out vec4 compat_TexCoord;

void main() {
	
	//gl_Position = ftransform(); // for testing COLOR buffer - equivalent to: gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex
	
	gl_Position = ProjMatrix * MVP * ModelMatrix * gl_Vertex;
	
	compat_TexCoord = gl_MultiTexCoord0; // for testing COLOR buffer
	
}
