#version 400
// version 400 was released in 2010. https://en.wikipedia.org/wiki/OpenGL_Shading_Language


// Input vertex data, different for all executions of this shader.
//layout(location = 0) in vec3 vertexPosition_modelspace;

// matrixes
uniform mat4 depthMVP;		// camera transform modelview
uniform mat4 ModelMatrix;	// local model transform (is needed currently to render vehicles)
uniform mat4 ProjMatrix;	// current projection matrix
uniform bool uDebugShadowmap;

void main() {
	
	//gl_Position = ftransform(); // for testing COLOR buffer - equivalent to: gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex
	
	gl_Position = ProjMatrix * depthMVP * ModelMatrix * gl_Vertex;
	
	gl_TexCoord[0] = gl_MultiTexCoord0; // for testing COLOR buffer
	
}
